###############################################################################
##
##  Copyright (C) 2011-2013 Tavendo GmbH
##
##  Licensed under the Apache License, Version 2.0 (the "License");
##  you may not use this file except in compliance with the License.
##  You may obtain a copy of the License at
##
##      http://www.apache.org/licenses/LICENSE-2.0
##
##  Unless required by applicable law or agreed to in writing, software
##  distributed under the License is distributed on an "AS IS" BASIS,
##  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
##  See the License for the specific language governing permissions and
##  limitations under the License.
##
###############################################################################

import random, struct

## http://stackoverflow.com/questions/15014310/python3-xrange-lack-hurts
try:
   xrange
except NameError:
   ## Python 3
   xrange = range


def randomByteString(len):
   """
   Generate a string of random bytes.
   """
   ll = int(len / 8 + int(len % 8 > 0))
   return b''.join([struct.pack("!Q", random.getrandbits(64)) for _ in xrange(0, ll)])[:len]
